<template>
  <div class="py-8 px-8">
    <h4 class="grey--text" style="margin-left: -10px">
      <v-btn icon class="mb-1" @click="$router.push('/')"
        ><v-icon>mdi-arrow-left</v-icon></v-btn
      >Back to Home
    </h4>
    <h1 class="mb-0">
      Photo Album
    </h1>
    <div v-if="!loading_user">
      <h3 class="grey--text mb-0">
        <nuxt-link :to="`/user?user_id=${datas_user[0].id}`">{{
          datas_user[0].name
        }}</nuxt-link>
        <v-icon class="blue--text">mdi-link-variant</v-icon>
      </h3>
      <h4 class="grey--text">
        {{ datas_user[0].email }}
      </h4>
    </div>
    <v-card elevation="5" class="mt-4">
      <v-card-text>
        <v-row v-if="loading" class="mt-8">
          <v-col v-for="(item, i) in 8" :key="i" lg="3" md="3" sm="6" cols="12">
            <v-skeleton-loader
              class="mx-auto"
              max-width="300"
              type="card"
            ></v-skeleton-loader>
          </v-col>
        </v-row>
        <div v-else class="container-img">
          <v-row>
            <v-col
              v-for="(item, i) in datas_photo"
              :key="i"
              lg="3"
              md="3"
              sm="6"
              cols="12"
            >
              <div class="container-img">
                <v-btn icon class="favorite-icon" @click="addToFavourite(item)"
                  ><v-icon
                    :class="
                      `${checkFavouriteExist(item) === 1 ? 'yellow--text' : ''}`
                    "
                    large
                    >{{
                      checkFavouriteExist(item) === 1
                        ? "mdi-star"
                        : "mdi-star-outline"
                    }}</v-icon
                  ></v-btn
                >
                <img
                  :src="
                    item.url ||
                      'https://www.generationsforpeace.org/wp-content/uploads/2018/03/empty.jpg'
                  "
                  :alt="`image`"
                  @click="openDialogPhoto(item)"
                />
                <div class="figcaption">{{ item.title }}</div>
              </div>
            </v-col>
          </v-row>
        </div>
      </v-card-text>
    </v-card>

    <v-dialog v-model="dialog_photo" max-width="800">
      <v-card>
        <v-toolbar color="primary" dark
          >Detail Photo
          <v-btn text class="ml-auto" @click="dialog_photo = false"
            >Close</v-btn
          >
        </v-toolbar>
        <CommentDialog
          v-if="dialog_photo_item"
          :dialog-photo-item="dialog_photo_item"
        />
      </v-card>
    </v-dialog>
  </div>
</template>

<script>
import CommentDialog from "@/components/CommentDialog";
export default {
  layout: "albumId",
  components: {
    CommentDialog
  },
  data() {
    return {
      dialog_photo: false,
      dialog_photo_item: null
    };
  },
  computed: {
    datas_photo() {
      return this.$store.get("datas_photo");
    },
    loading() {
      return this.$store.get("loading_photo");
    },
    datas_user() {
      return this.$store.get("datas_user");
    },
    loading_user() {
      return this.$store.get("loading_user");
    }
  },
  watch: {
    dialog_photo(val) {
      if (!val) {
        this.dialog_photo_item = null;
      }
    }
  },
  created() {
    this.load();
  },
  methods: {
    load() {
      this.$store.dispatch("loadPhotos", this.$route.query.id);
      this.$store.dispatch("loadUsers", this.$route.query.user_id);
    },
    addToFavourite(item) {
      if (this.checkFavouriteExist(item) === 0) {
        this.$store.dispatch("addToFavourite", item);
        this.$forceUpdate();
      }
    },
    checkFavouriteExist(item) {
      const is_exist = JSON.parse(localStorage.getItem("favourites-photo"))
        ? JSON.parse(localStorage["favourites-photo"]).filter(
            obj => obj.id === item.id && obj.albumId === item.albumId
          ).length
        : 0;
      return is_exist;
    },
    openDialogPhoto(item) {
      this.dialog_photo = true;
      this.dialog_photo_item = item;
    }
  }
};
</script>

<style lang="scss" scoped>
.container-img {
  position: relative;
  img {
    width: 100%;
    cursor: pointer;
  }
  .favorite-icon {
    top: 10px;
    right: 10px;
    position: absolute;
  }

  .figcaption {
    position: absolute;
    bottom: 0;
    left: 0;
    background-color: rgba(255, 255, 255, 0.5);
    padding: 0.2em 0.5em 0.8em 0.5em;
    justify-self: start;
  }
}
</style>
